<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

    use \Teknisa\GER\Libraries\PHPMailer;
    use Teknisa\CDP\Controllers\TeknisaCrud;
    use Teknisa\GER\Controllers\CrudController;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use \Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;

    class cdp01300OcorrenciaDaProducaoController extends TeknisaCrud {
        protected $dataSourceName = 'grupocor';
        protected $dataSourceNameToSave = '';
        protected $cdp01300OcorrenciaDaProducaoService;
  
        public function __construct($crudService, ParameterBag $parameterBag, $cdp01300OcorrenciaDaProducaoService){
            parent::__construct($crudService, $parameterBag);
            $this->cdp01300OcorrenciaDaProducaoService = $cdp01300OcorrenciaDaProducaoService;
        }

        public function deletarGrupoOcorrencia(DTO\Request $request, DTO\Response $response){
            try {
                $rows = $request->getRow();
                $this->cdp01300OcorrenciaDaProducaoService->deleteGrupoOcorrencia($rows);
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 500));
            }
        }
        
    }
?>