<?php
namespace Teknisa\CDP\Modules\Producao\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Teknisa\CDP\Modules\Producao\Factories\ger24000HabilidadeFactory;


class ger24000HabilidadeService{

	protected $entityManager;
	protected $environment;
	protected $ger24000HabilidadeFactory;
	protected $newCode;

	public function __construct(Environment $environment, EntityManager $entityManager, ger24000HabilidadeFactory $ger24000HabilidadeFactory, newCode $newCode){
		$this->environment				= $environment;
		$this->entityManager           = $entityManager;
		$this->ger24000HabilidadeFactory = $ger24000HabilidadeFactory;
		$this->newCode = $newCode;
	}

	public function save ($rows){
    	try{
        	$connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            $this->saveCustohab($rows[0]);
        	$this->saveHabilidade($rows[1]);
        	
        	$connection->commit();
        	
        }catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
    }
    
    private function saveCustohab($row){
        
        $nrSequencial = $this->newCode->getCodeByTableName('CUSTOHAB', $this->environment->getNrorg(), 1, 3, false);
        
        if($row['__is_new']){
            $params = array(
                'CDHABILIDADE'=>$row['CDHABILIDADE'], 
                'CDCUSTOHAB'=>$nrSequencial, 
                'DSCUSTOHAB'=>$row['DSCUSTOHAB'], 
                'VRCUSTOHAB'=>$row['VRCUSTOHAB'], 
                'CDCONTCTBLHAB'=>$row['CDCONTCTBLHAB'],
                'NRORG'=>$this->environment->getNrorg()
            );
            $this->ger24000HabilidadeFactory->insertCustohab($params);
        }
        else{
            $params = array(
                'CDHABILIDADE'=>$row['CDHABILIDADE'], 
                'CDCUSTOHAB'=>$row['CDCUSTOHAB'], 
                'DSCUSTOHAB'=>$row['DSCUSTOHAB'], 
                'VRCUSTOHAB'=>$row['VRCUSTOHAB'], 
                'CDCONTCTBLHAB'=>$row['CDCONTCTBLHAB'],
                'NRORG'=>$this->environment->getNrorg()
            );
            $this->ger24000HabilidadeFactory->updateCustohab($params);
        }
        
        
    }
    
    private function saveHabilidade($row){
        
         $params = array(
            'VRCUSHRHABIL'=>$row['VRCUSHRHABIL'],
            'CDHABILIDADE'=>$row['CDHABILIDADE'], 
            'NRORG'=>$row['NRORG']
        );
        
        $this->ger24000HabilidadeFactory->updateHabilidade($params);
    }

}